proc iml;
	start E2(mm_y,mm_mu,mm_l,mm_s,mm_N,mm_eta,mm_lkhd);
		do i = 1 to mm_N;
			l_i = mm_l[i,]`;
			inv_vy = inv(l_i*l_i` + diag(mm_s));
			/*Change*/y_i = mm_y[i,]` - mm_mu;

			eta = l_i` * inv_vy * y_i;
			eta2 = 1 - (l_i` * inv_vy * l_i);
			mm_lkhd = mm_lkhd - (y_i` * inv_vy * y_i) + log(det(inv_vy));
			mm_eta[i,] = eta || eta2;
			free l_i inv_vy y_i eta eta2;
		end;
	finish;

	start M_SVD2(mm_RBm,mm_y,mm_X1,mm_qy,mm_nb,mm_N,
				mm_Pm_inv,mm_UU1,mm_uqy,mm_dt1,mm_dt2,mm_GCV,mm_l,mm_s,mm_b,mm_mu)
	;
		call svd(Um,Dm,Vm,mm_RBm);

		/*Change*/idx_UU1 = 1 : 1+mm_nb;
		mm_UU1 = Um[idx_UU1,]` * Um[idx_UU1,];
		mm_Pm_inv = (1/Dm)` # Vm;
		mm_uqy = Um[idx_UU1,]` * mm_qy;
		free Dm Vm;

		/*Change*/idx_UU2 = 1+mm_nb+1 : 1+mm_nb+mm_nb;
		UU2 = Um[idx_UU2,]` * Um[idx_UU2,];
		mm_s = (mm_y[##,] + mm_uqy`*(mm_UU1+UU2-2#i(1+mm_nb))*mm_uqy) / mm_N;
		th = mm_Pm_inv * mm_uqy;
		free Um UU2;

		mm_mu = th[1,];
		mm_l = th[2,];
		if mm_nb > 1 then mm_b = th[1+2:1+mm_nb,];

		mm_dt1 = mm_N - trace(mm_UU1);
		mm_dt2 = ssq(mm_y - mm_X1*th);
		mm_GCV = mm_N#mm_dt2/(mm_dt1##2); 
	finish;

	reset storage=pj1a.sim2_module; 
	store module=(E2 M_SVD2);
quit;
